<script>
	import {fade} from 'svelte/transition'
	const scrollAndFade = (e, ...params)=>{
		const data =  fade(e, ...params)
		data.tick = ()=> e.parentElement.parentElement.scrollTop = e.parentElement.parentElement.scrollHeight
		return data
	}

	export let messages = []
</script>
<style>
	#viewbox{
		flex: 1 1 auto;
		display: flex;
		flex-flow: column;
		overflow-y: auto;
	}
	#messages{
		flex: 1 1 auto;
		display: flex;
		flex-flow: column;
		justify-content: flex-end;
		align-items: flex-start;
	}
	.message{
		margin: 0.6em;
		padding: 0.4em 0.7em;
		background-color: var(--color2);
		display: flex;
		flex-flow: row;
	}
	.name{
		font-style: italic;
		margin-right: 0.4em;
	}
	.content{
		display: inline-block;
		margin: 0em;
		white-space: pre-wrap;
	}
	.system{
		font-weight: bolder;
		color: var(--color1)
	}
</style>
<div id='viewbox'>
	<div id='messages'>
		{#each messages as message}
			{#if message.name}
				<div class='message' in:scrollAndFade out:fade>
					<span class='name'>{message.name}: </span>
					<p class='content'>{message.message}</p>
				</div>
			{:else}
			<div class='message system'>
				{message.message}
			</div>
			{/if}
		{/each}
	</div>
</div>
